package demo;

import java.awt.event.ActionEvent;
import java.io.UnsupportedEncodingException;

import javax.swing.AbstractAction;
import javax.swing.Action;
import javax.swing.JDialog;
import javax.swing.JScrollPane;
import javax.swing.JTextArea;
import javax.swing.UIManager;

import com.japisoft.ftpbrowser.FTPBrowser;
import com.japisoft.resourcebrowser.State;

/**
 * This is a demo for displaying a file through FTP
 * @author (c) 2004 JAPISoft / http://www.japisoft.com
 * @version 1.0
 * */
public class FTPBrowserDemo {

	FTPBrowser browser;
	JDialog dialog;
	
	public FTPBrowserDemo() {
		dialog = new JDialog();
		dialog.setModal( true );
		dialog.setTitle( "FTP Editor " );

		// We initialize a default FTP server and user account
		State state = new State();
		state.putValue( State.HOST_KEY, "MyHost" );
		state.putValue( State.USER_KEY, "MyUserName" );
		state.putValue( State.PASSWORD_KEY, "MyPassword" );
		
		dialog.getContentPane().add( browser = new FTPBrowser( state ) );

		// We add a new action inside the FTPBrowser for displaying a file content
		browser.getActionModel().addAction( new DisplayAction() );
		
		dialog.setSize( 500, 550 );
		dialog.setVisible( true );

		// It will close the browsed file as it is in a modal state
		dialog.dispose();		
	}

	/** Here a new action for displaying a file content */
	class DisplayAction extends AbstractAction {
		public DisplayAction() {
			putValue( Action.NAME, "Display" );
		}

		public void actionPerformed( ActionEvent e ) {

			byte[] content = browser.getSelectedContentFile( false );
			if ( content != null ) {

				try {
					String text = new String( content, "UTF8" );
					JDialog dialog2 = new JDialog( dialog );
					JTextArea area = new JTextArea( text );
					dialog2.getContentPane().add( new JScrollPane( area ) );
					dialog2.setSize( 400, 400 );
					dialog2.setVisible( true );
				} catch( UnsupportedEncodingException exc ) {}

			}

		}
	}
	
	public static void main( String[] args ) {
		try {
			UIManager.setLookAndFeel( UIManager.getSystemLookAndFeelClassName() );
		} catch( Exception exc ) {
		}

		new FTPBrowserDemo();
	}

}
